<template>
  <div>
    <v-app>
      <v-content>
        <div>
          <h2>Skills</h2>
          <v-btn flat color="blue-grey darken-3" style="padding-bottom: 7px" @click="dialog = true">
            <v-icon>library_add</v-icon>
          </v-btn>
        </div>
        <v-container fluid>
          <v-layout>
          <v-flex xm12>
            <v-text-field
              v-model="searchTitle"
              v-on:input="searchSkillsBy('title',searchTitle)"
              append-icon="search"
              label="Search by title"
              single-line
              hide-details
            ></v-text-field>
            </v-flex>
        <v-spacer></v-spacer>
        <v-text-field
          v-model="searchType"
          v-on:input="searchSkillsBy('type',searchType)"
          append-icon="search"
          label="Search by type"
          single-line
          hide-details
        ></v-text-field>
        <v-spacer></v-spacer>
        <v-text-field
          v-model="searchCategory"
          v-on:input="searchSkillsBy('category',searchCategory)"
          append-icon="search"
          label="Search by category"
          single-line
          hide-details
        ></v-text-field>
        <v-spacer></v-spacer>
        <v-text-field
          v-model="search"
          append-icon="search"
          label="Search by..."
          single-line
          hide-details
        ></v-text-field>
            </v-layout>
        </v-container>
        <v-card>
      <v-data-table
        :headers="headers"
        :items="items"
        :search="search"

      >
        <template v-slot:items="props" style="color: green">
          <tr @click="openSkillCard(props.item.id)">
            <td>{{ props.item.title }}</td>
            <td class="text-xs">{{ props.item.type }}</td>
            <td class="text-xs">{{ props.item.category }}</td>
            <td class="text-xs">{{ props.item.version }}</td>
            <td class="text-xs">{{ props.item.employees }}</td>
            <td class="text-xs">{{ props.item.projects }}</td>
            <td class="text-xs">{{ props.item.tags }}</td>
          </tr>
        </template>
        <v-alert v-slot:no-results :value="true" color="error" icon="warning">
          Your search for "{{ search }}" found no results.
        </v-alert>
      </v-data-table>
    </v-card>
      </v-content>
      <v-dialog
        v-model="dialog"
        max-width="900">
        <v-card>
          <h2>Add new skill</h2>
          <v-card-text>
            <v-form>
              <v-flex>
                <v-text-field
                  v-model="newSkill.title"
                  label="Title"
                  required
                ></v-text-field>
              </v-flex>
              <v-flex>
              <v-select
                v-model="newSkill.type"
                :items="skillsTypes"
                :menu-props="{ maxHeight: '400' }"
                label="Type"
                persistent-hint>
              </v-select>
              </v-flex>
                <v-select
                  v-model="newSkill.category"
                  :items="skillsCategories"
                  :menu-props="{ maxHeight: '400' }"
                  label="Category"
                  persistent-hint>
              </v-select>
                <v-flex>
                  <v-text-field
                    v-model="newSkill.version"
                    label="Version"
                    required>
                  </v-text-field>
                </v-flex>
                <v-flex>
                  <v-text-field
                    v-model="newSkill.url"
                    label="Website URL"
                    required>
                  </v-text-field>
                </v-flex>
                <v-flex>
                  <v-text-field
                    v-model="newSkill.git"
                    label="Git URL"
                    required>
                  </v-text-field>
                </v-flex>
                <v-flex>
                  <v-select
                    v-model="newSkill.connectedCategories"
                    :items="skillsCategoriesConnected"
                    :menu-props="{ maxHeight: '400' }"
                    label="Connected categories"
                    multiple
                    persistent-hint>
                  </v-select>
                </v-flex>
                <v-flex>
                  <v-select
                    v-model="newSkill.parentSkill"
                    :items="parentSkills"
                    item-text="title"
                    :menu-props="{ maxHeight: '400' }"
                    label="Parent skill"
                    persistent-hint>
                  </v-select>
                </v-flex>
              <v-flex>
                  <v-select
                    v-model="newSkill.childSkills"
                    :items="childSkills"
                    item-text="title"
                    :menu-props="{ maxHeight: '400' }"
                    label="Child skills"
                    multiple
                    persistent-hint>
                  </v-select>
                </v-flex>
                <v-flex>
                  <v-text-field
                    v-model="newSkill.tags"
                    label="Tags"
                    required
                  ></v-text-field>
                </v-flex>
                <v-flex>
                  <v-text-field
                    v-model="newSkill.description"
                    label="Description"
                    required
                  ></v-text-field>
                </v-flex>
            </v-form>
          </v-card-text>
          <div align="center">
            <v-spacer></v-spacer>
            <v-btn
              color="blue-grey darken-3"
              flat="flat"
              @click="dialog = false">
              Cancel
            </v-btn>
            <v-btn
              color="blue-grey darken-3"
              flat="flat"
              @click="addNewSkill(newSkill)">
              Save
            </v-btn>
          </div>
        </v-card>
      </v-dialog>
    </v-app>
  </div>
</template>

<script>
export default {
  name   : 'SkillsList',
  data () {
    return {
      searchTitle              : '',
      searchType               : '',
      searchCategory           : '',
      searchTags               : [],
      search                   : '',
      dialog                   : false,
      skillsTypes              : ['SkillType1', 'SkillType2'],
      skillsCategories         : ['Cat1', 'Cat2'],
      skillsCategoriesConnected: ['Cat1', 'Cat2'],
      headers                  : [
        {text: 'Title', value: 'title', align: 'center'},
        {text: 'Type', value: 'type', align: 'center'},
        {text: 'Category', value: 'category', align: 'center'},
        {text: 'Version', value: 'version', align: 'center'},
        {text: 'Employees', value: 'employees', align: 'center'},
        {text: 'Projects', value: 'projects', align: 'center'},
        {text: 'Tags', value: 'tags', align: 'center'}
      ],
      unfilteredItems          : [],
      items                    : [],
      parentSkills             : [],
      childSkills              : [],
      newSkill                 : {
        id                 : '',
        title              : '',
        type               : '',
        category           : '',
        url                : '',
        git                : '',
        connectedCategories: [],
        parentSkill        : {},
        childSkills        : [],
        tags               : [],
        description        : '',
        version            : '',
        employees          : '',
        projects           : ''
      }
    }
  },
  // validations : {
  //   newSkill: {
  //     title: {
  //       required: Vuelidate.required,
  //       minLength: Vuelidate.minLength(5)
  //     }
  //   }
  // },
  beforeMount () {
    // this.$store.commit('setSkills')
    this.items = this.$store.getters.getSkills;
    this.parentSkills = [];
    this.childSkills = [];
    let len = this.items.length
    for (let i = 0; i < len; i++) {
      this.unfilteredItems.push(this.items[i]);
      this.parentSkills.push(this.items[i]);
      this.childSkills.push(this.items[i]);
    }
  },
  methods: {
    addNewSkill (newSkill) {
      alert('new skill: ' + newSkill)
      // todo: add real logic for version, employees and description
      // todo: make more good ID generation
      // todo: avoid creating empty skill!

      // todo: add check if parent skill === child skill!


      let tags = newSkill.tags.split(',')
      this.$store.commit('addSkill', {
        data: {
          id                 : Math.floor(Math.random() * 10000),
          title              : newSkill.title,
          type               : newSkill.type,
          category           : newSkill.category,
          url                : newSkill.url,
          git                : newSkill.git,
          connectedCategories: newSkill.connectedCategories,
          parentSkill        : newSkill.parentSkill,
          childSkills        : newSkill.childSkills,
          tags               : tags,
          description        : newSkill.description,
          version            : '1.0',
          employees          : 0,
          projects           : 0
        }
      })
      this.items = this.$store.getters.getSkills
      this.unfilteredItems = []
      let len = this.items.length
      for (let i = 0; i < len; i++) {
        this.unfilteredItems.push(this.items[i])
      }
      this.dialog = false
    },
    openSkillCard (id) {
      this.$router.push('/main/skillcard/' + id)
      // alert('open skill card!')
    },
    // title, type, category, NOT tags
    searchSkillsBy (param, searchStr) {
      this.items = this.unfilteredItems
      if (!param) {
        return
      }
      if (!searchStr) {
        this.items = this.unfilteredItems
        return
      }
      let len = this.items.length
      let res = []
      for (let i = 0; i < len; i++) {
        if (this.items[i][param].includes(searchStr)) {
          res.push(this.items[i])
        }
      }
      this.items = res
    }
  }
}
</script>

<style scoped>

  h2 {
    font-family    : 'Avenir', Helvetica, Arial, sans-serif;
    padding-top    : 10px;
    padding-bottom : 20px;
    display        : inline-block;
  }
</style>
